
!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Sorting Algorithms</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Sorting Algorithms</h1>    
                    </section>
                    <section>
                        <h2>Sorting Algorithms Overview</h2>
                    </section>
                    <section>
                        <h2>Objectives</h2>
					</section>
					<section>
						<h2>Sorting Algorithms</h2>
						<ul>
							<li>Bubble Sort</li>
							<li>Insertion Sort</li>
							<li>Selection Sort</li>
							<li>Merge Sort</li>
							<li>Quick Sort</li>
						</ul>
						
					</section>
                </section>
                <!-- Coding Style Guide Section -->
                <section>   
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
						<h2>Bubble Sort</h2>
						<ul>
						
						<li> an algorithm that compares the adjacent elements and swaps their positions if they are not in the intended order</li>
						<li>The order can be ascending or descending</li>
						</ul>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>
					<section>
						<h3>Bubble Sort process</h3>
						<img src="../../../assets/sort1.png" alt="sort1">
					</section>
					<section>
						<h2>BubbleSort Algorithm</h2>
						<pre>
							<code data-trim data-noescape>
								begin BubbleSort(list)

								for all elements of list
								   if list[i] > list[i+1]
									  swap(list[i], list[i+1])
								   end if
								end for
								
								return list
								
							 end BubbleSort
							</code>
						</pre>
					</section>
					<section>
						<h2>Bubble sort pseudocode </h2>
							<pre>
							<code data-trim data-noescape>
								procedure bubbleSort( list : array of items )

									loop = list.count;
									
									for i = 0 to loop-1 do:
										swapped = false
											
										for j = 0 to loop-1 do:
										
											/* compare the adjacent elements */   
											if list[j] > list[j+1] then
												/* swap them */
												swap( list[j], list[j+1] )		 
												swapped = true
											end if
											
										end for
										
										/*if no number was swapped that means 
										array is sorted now, break the loop.*/
										
										if(not swapped) then
											break
										end if
										
									end for
									
								end procedure return list
							</code>
						</pre>
					</section>
					<section>
						<h2>Bubble Sort Example Demo</h2>
						
					</section>
					
		
					
                </section>
                <!-- Arrays Section -->
                <section>
                    <section>
                        <h2>Insertion Sort Algorithm</h2>
						<p>Insertion sort is a sorting algorithm that places an unsorted element at its suitable place in each iteration</p>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Insertion Sort </h2>
						<img src="../../../assets/sort2.png" alt="sort2">
					</section>
					<section>
						<h3>Insertion Sort Algorithm</h3>
						<pre>
							<code data-trim data-noescape>
								Step 1 − If it is the first element, it is already sorted. return 1;
								Step 2 − Pick next element
								Step 3 − Compare with all elements in the sorted sub-list
								Step 4 − Shift all the elements in the sorted sub-list that is greater than the 
										 value to be sorted
								Step 5 − Insert the value
								Step 6 − Repeat until list is sorted
							</code>
						</pre>
				</section>
				<section>
					<h3>Insertion Sort pseudocode</h3>
					<pre>
						<code data-trim data-noescape>
							procedure insertionSort( A : array of items )
							int holePosition
							int valueToInsert
								
							for i = 1 to length(A) inclusive do:
								
								/* select value to be inserted */
								valueToInsert = A[i]
								holePosition = i
								
								/*locate hole position for the element to be inserted */
									
								while holePosition > 0 and A[holePosition-1] > valueToInsert do:
									A[holePosition] = A[holePosition-1]
									holePosition = holePosition -1
								end while
									
								/* insert the number at hole position */
								A[holePosition] = valueToInsert
								
							end for
								
							end procedure
						</code>
					</pre>
				</section>
				<section>
					<h3>Insertion Sort Example Demo</h3>

				</section>
                </section>
                <!-- Access & Modify Arrays Section -->
                <section>
                         <section>
                        <h2>Selection Sort Algorithm</h2>
						<p>an algorithm that selects the smallest element from an unsorted list in each iteration and places that element at the beginning of the unsorted list</p>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h3>Selection Sort</h3>
						<img src="../../../assets/sort3.png" alt="sort3">
					</section>
                    <section>
						<h2>Selection Sort Algorithm </h2>
						<pre>
							<code data-trim data-noescape>
								Step 1 − Set MIN to location 0
								Step 2 − Search the minimum element in the list
								Step 3 − Swap with value at location MIN
								Step 4 − Increment MIN to point to next element
								Step 5 − Repeat until list is sorted

							</code>
						</pre>
					</section>
					<section>
						<h3>Selection Sort Pseudocode</h3>
						<pre>
							<code data-trim data-noescape>
								procedure selection sort 
								list  : array of items
								n     : size of list
							 
								for i = 1 to n - 1
								/* set current element as minimum*/
								   min = i    
							   
								   /* check the element to be minimum */
							 
								   for j = i+1 to n 
									  if list[j] < list[min] then
										 min = j;
									  end if
								   end for
							 
								   /* swap the minimum element with the current element*/
								   if indexMin != i  then
									  swap list[min] and list[i]
								   end if
								end for
								 
							 end procedure
							</code>
						</pre>
				</section>
				
				<section>
					<h3>Selection Sort Example Demo</h3>
					
				</section>
                  
				</section>
				<!-- next Section -->
				<section>
					<section>
				   <h2>Quick Sort Algorithm</h2>
				   <p>an algorithm based on divide and conquer approach in which the array is split into subarrays and these sub-arrays are recursively called to sort the elements.</p>
				   <aside class="notes">
					   Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
				   </aside>
			   </section>
			   <section>
				   <h3>Quick Sort</h3>
				   <img src="../../../assets/sort5.png" alt="sort5">
			   </section>
			   <section>
				   <h3>Quicksort is approached by the:</h3>
				   <ul>
					   <li>Divide</li>
					   <li>Conquer</li>
					   <li>Combine</li>
				   </ul>
			   </section>
			   <section>
				   <h2>Quick Sort Algorithm </h2>
				   <pre>
					   <code data-trim data-noescape>
						Step 1 − Choose the highest index value has pivot
						Step 2 − Take two variables to point left and right of the list excluding pivot
						Step 3 − left points to the low index
						Step 4 − right points to the high
						Step 5 − while value at left is less than pivot move right
						Step 6 − while value at right is greater than pivot move left
						Step 7 − if both step 5 and step 6 does not match swap left and right
						Step 8 − if left ≥ right, the point where they met is new pivot

					   </code>
				   </pre>
			   </section>
			   <section>
				   <h3>Quick Sort Pseudocode</h3>
				   <pre>
					   <code data-trim data-noescape>
						function partitionFunc(left, right, pivot)
							leftPointer = left
							rightPointer = right - 1
					 
						while True do
						   while A[++leftPointer] < pivot do
							  //do-nothing            
						   end while
							 
						   while rightPointer > 0 && A[--rightPointer] > pivot do
							  //do-nothing         
						   end while
							 
						   if leftPointer >= rightPointer
							  break
						   else                
							  swap leftPointer,rightPointer
						   end if
							 
						end while 
						 
						swap leftPointer,right
						return leftPointer
						 
					 end function
					   </code>
				   </pre>
		   </section>
		   
		   <section>
			   <h3>Quick Sort Example Demo</h3>
			   
		   </section>
			 
		   </section>

				<!-- Next Section -->
				<section>
					<section>
				   <h2>Merge Sort Algorithm</h2>
				   <p>an algorithm based on divide and conquer approach in which the array is split into subarrays and these sub-arrays are recursively called to sort the elements.</p>
				   <aside class="notes">
					   Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
				   </aside>
			   </section>
			   <section>
				   <h3>Merge Sort</h3>
				   <img src="../../../assets/sort4.jpeg" alt="sort4">
			   </section>
			   <section>
				   <h3>MergeSort is approached by the:</h3>
				   <ul>
					   <li>Divide</li>
					   <li>Conquer</li>
					   <li>Combine</li>
				   </ul>
			   </section>
			   <section>
				   <h2>Merge Sort Algorithm </h2>
				   <pre>
					   <code data-trim data-noescape>
						Step 1 − Choose the highest index value has pivot
						Step 1 − if it is only one element in the list it is already sorted, return.
						Step 2 − divide the list recursively into two halves until it can no more be divided.
						Step 3 − merge the smaller lists into new list in sorted order.

					   </code>
				   </pre>
			   </section>
			   <section>
				   <h3>Merge Sort Pseudocode</h3>
				   <pre>
					   <code data-trim data-noescape>
						procedure mergesort( var a as array )
							if ( n == 1 ) return a

							var l1 as array = a[0] ... a[n/2]
							var l2 as array = a[n/2+1] ... a[n]

							l1 = mergesort( l1 )
							l2 = mergesort( l2 )

							return merge( l1, l2 )
							end procedure

						procedure merge( var a as array, var b as array )

							var c as array
							while ( a and b have elements )
								if ( a[0] > b[0] )
									add b[0] to the end of c
									remove b[0] from b
								else
									add a[0] to the end of c
									remove a[0] from a
								end if
							end while
							
							while ( a has elements )
								add a[0] to the end of c
								remove a[0] from a
							end while
							
							while ( b has elements )
								add b[0] to the end of c
								remove b[0] from b
							end while
							
							return c
								
							end procedure
					   </code>
				   </pre>
		   </section>
		   
		   <section>
			   <h3>Merge Sort Example Demo</h3>
			   
		   </section>
			 
		   </section>
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>List</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
